// BidHistory.java
// Fall 2004, COP4331: Online auction example application
// 


/**
   the bid history class.

   NOTE: The purpose of this code is to illustrate implementation starting 
   from UML class and sequence diagrams. It may be incomplete and may not 
   compile.
*/
public class BidHistory {
    /**
       constructs the bid history
    */
    public BidHistory() {
	this.list = new java.util.ArrayList<Bid>();
    }

    /**
       return the highest bid. Returns null if there is no bid in the history.
       Derived from the "Complete Auction" use case.
       @return the highest bid. Returns null if there is no bid for item.
    */
    public Bid getHighestBid() {
	Bid bid = null;
	if (! this.list.isEmpty()) {
	    // return the last element in list (the most recently added)
	    // (Bid) cast is necessary because List.get() returns Object type:
	    bid = this.list.get(this.list.size() - 1);
	}

	return bid;
    }
       

    /**
       save a bid to the history.
       Derived from the "Bid for Item" use case.
       @param bid the new bid
    */
    public void addBid(Bid bid) {
	// bid is added at the tail of the list (last element):
	this.list.add(bid);
    }
    

    // instance variable:
    /**
       collection of Bid objects. <CODE>List</CODE> is an interface type.
       @see ArrayList
       @see Bid
    */
    private java.util.ArrayList<Bid> list;
};
