// BrowseList.java
// Fall 2004, COP4331: Online auction example application
// 


/**
   list of auction listings intended for users.

   NOTE: The purpose of this code is to illustrate implementation starting 
   from UML class and sequence diagrams. It may be incomplete and may not 
   compile.
*/
public class BrowseList {

    /**
       constructs a new BrowseList object. Called by <CODE>ActiveList</CODE> class
       during <CODE>getBrowseList()</CODE>.
       This class is necessary because users must not be given access to the ActiveList object.
       It provides a minimal interface for read-only access to list content.
       @see ActiveList
    */
    public BrowseList() {
	this.list = new java.util.ArrayList<AuctionListing>();
    }


    /**
       adds an <CODE>AuctionListing</CODE> object to the list
       @param al the auction listing
       @see AuctionListing
    */
    public void addListing(AuctionListing al) {
	this.list.add(al);
    }

    /**
       return list size (element count)
       @return list size (element count)
    */
    public int size() {
	return this.list.size();
    }

    /**
       return listing at element index
       @return listing at element index
    */
    public AuctionListing get(int index) {
	return this.list.get(index);
    }

    // instance variables:
    /**
       list of AuctionListing objects:
    */
    private java.util.ArrayList<AuctionListing> list;
};
